import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.SQLException;
import java.util.concurrent.ExecutionException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.RepaintManager;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * <p>
 * This program displays a LERG search panel to users. Fields. that are editable
 * can be used for searches. Searches can be run with multiple fields. Any
 * editable field that is not empty will be used for a search. Searches with
 * multiple results can be browsed through by using the first, prev, next, and
 * last buttons.
 * </p>
 * 
 * @author szakrews
 * 
 */
public class TestClass2 extends JFrame implements ActionListener {

	/** Action Command for <code>searchbtn</code> */
	public static final String SEARCH_BTN_ACTION = "search_btn_action";

	/**
	 * Constructor.
	 */
	public TestClass2() {

		setSize(650, 350);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation(screenSize.width / 2 - getSize().width / 2,
				screenSize.height / 2 - getSize().height / 2);

		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				exit();
			}
		});

		JPanel panel = new JPanel();
		add(panel);
		setVisible(true);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals(SEARCH_BTN_ACTION)) {
			JOptionPane.showMessageDialog(this, "Button Pressed");
		}
	}
	
	public void showWait() {
		try {
			WaitDialog.showWaitDialog(this, "Testing...", new SwingWorkerInterface(){

				@Override
				public Object workToDo() throws Throwable {
					Thread.currentThread().sleep(3000);
					return null;
				}
				
			});
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ExecutionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Exits the program.
	 */
	public void exit(){
		System.exit(0);
	}
	
	/**
	 * Create the GUI and show it. For thread safety, this method should be
	 * invoked from the event-dispatching thread.
	 * @throws UnsupportedLookAndFeelException 
	 * @throws IllegalAccessException 
	 * @throws InstantiationException 
	 * @throws ClassNotFoundException 
	 * @throws NullInstanceVariableException 
	 * @throws SQLException 
	 */
	private static void createAndShowGUI() { 
		
		// set look and feel
		try{
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

			// Create instance of the ProductCatalog
			TestClass2 root = new TestClass2();
			for(int i = 0; i < 10; i++){
				root.showWait();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	/**
	 * @param args
	 *            this program does not use arguments
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				createAndShowGUI();
			}
		});
	}
}
